/* ana.cc  Data Analyzing program for Linux */

#include <Xm/Xm.h>
#include <Xm/MainW.h>
#include <Xm/Form.h>
#include <Xm/List.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/RowColumn.h>
#include <Xm/DrawingA.h>
#include <Xm/CascadeB.h>
#include <Xm/SeparatoG.h>
#include <Xm/PushBG.h>
#include <Xm/PushB.h>
#include <Xm/Text.h>
#include <X11/Xmu/Editres.h>
#include <X11/xpm.h>
#include "icon.h"
#include "vregist.h"
#include "Toolbar/Toolbar.h"
/* include pixmaps for Toolbar */
#include "pixmaps/zoom_in.xpm"
#include "pixmaps/zoom_out.xpm"
#include "pixmaps/Left.xpm"
#include "pixmaps/left.xpm"
#include "pixmaps/right.xpm"
#include "pixmaps/Right.xpm"
#include "pixmaps/mark_set.xpm"
#include "pixmaps/mark_clear.xpm"
#include "pixmaps/mark_zoom.xpm"
#include "pixmaps/zoom_sel.xpm"
#include "pixmaps/total.xpm"

#define VERSION "3.3"
#define DISW 500           // display width
#define DISH 300           // display hight
#define LMAR 50            // left margin for y-axis
#define TICWIDTH 5         // width of the tics of the y-axis

/* global variables          */
/* Structure for menu system */
typedef struct {
  Widget f_menu;
  Widget n_data;
  Widget l_data;
  Widget s_data;
  Widget p_data;
  Widget quit;
} f_menu;

typedef struct {
  Widget e_menu;
  Widget mean;
  Widget area;
  Widget min;
  Widget max;
  Widget dif;
  Widget deltax;
  Widget copy;
  Widget del; 
  Widget reduce;
} e_menu;

typedef struct {
  Widget c_menu;
  Widget hr1;
  Widget hr2;
  Widget filter;
  Widget interpol;
  Widget movavg;
  Widget seqavg;
  Widget rectify;
  Widget invert;
  Widget differentiate;
  Widget linear;
  Widget twochtrans;
  Widget fft;
  Widget baro;
  Widget artifact;
} c_menu;

typedef struct {
  Widget v_menu;
  Widget redraw;
  Widget zoom;
  Widget total;
  Widget hide;
  Widget all;
  Widget comments;
} v_menu;

typedef struct {
  f_menu file;
  e_menu edit;
  c_menu calc;
  v_menu view;
} main_menu;

typedef struct {
Widget l;
Widget a;
Widget button_fb;
Widget button_ff;
Widget button_b;
Widget button_f;
Widget button_setmark;
Widget button_clearmark;
Widget button_in;
Widget button_out;
Widget button_snip_sel;
Widget button_zoommark;
Widget button_total; 
Widget rowcol_w;
} message_bar;

String colors[] = {"Black", "Blue", "Green", "Red", "Yellow", "Magenta", "Cyan", "White"};

XtAppContext app;
message_bar  mess;
Widget       drawing_a, toolb_w;

Widget       c_list_w;
main_menu    mymenu;
VREGIST      r;                  // registration;


main(int argc, char *argv[])
{
  Pixmap    bitmap;
  Widget    toplevel, main_w, form_w, pb_w;
  
  Widget    menubar, PullDown;
  Widget    comments_w, c_main_w, c_menubar, c_menu;
  char      message[100];

  extern void f_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void p_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void e_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void c_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void v_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void v_cb_add(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void da_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void mouse_trap(Widget widget, XtPointer client_data, XEvent *event, char *text);
  Widget GetTopLevelShell(Widget w);
  void c_f_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void SetPixmap(Widget w, char *pix[]);

  toplevel=XtVaAppInitialize(&app, "XmAna", NULL, 0,
			      &argc, argv, NULL, NULL);
  bitmap=XCreatePixmapFromBitmapData(XtDisplay(toplevel),
			  RootWindowOfScreen(XtScreen(toplevel)),
			  xmana_icon_bits, xmana_icon_width, xmana_icon_height,
			  1,0,1);
  XtVaSetValues(toplevel, 
		XmNiconPixmap, bitmap,
		XmNtitle, "xmana v"VERSION,
		NULL);
  XtAddEventHandler(toplevel, (EventMask)0, True,
		    _XEditResCheckMessages, NULL);

  /* create comments window but do not show */
  comments_w=XtVaCreatePopupShell("comments", topLevelShellWidgetClass, toplevel,
				  XmNtitle, "List of Comments",
				  XmNdeleteResponse, XmDO_NOTHING,
				  NULL);
  c_main_w=XtVaCreateManagedWidget("main_w", xmMainWindowWidgetClass, comments_w,
				   NULL);
  c_list_w=XtVaCreateManagedWidget("list_w", xmListWidgetClass, c_main_w,
				   XmNvisibleItemCount, 10,
				   NULL);
  c_menubar=XmVaCreateSimpleMenuBar(c_main_w, "menubar",
				    XmVaCASCADEBUTTON, XmStringCreateLocalized("File"), 'F',
				    NULL);
  c_menu=XmVaCreateSimplePulldownMenu(c_menubar, "file_menu", 0, c_f_cb,
				      XmVaPUSHBUTTON,
				      XmStringCreateLocalized("Close"), 'C', NULL, NULL,
				      NULL);
  XtManageChild(c_menubar);

  /*   m a i n w i n d o w    */
  main_w=XtVaCreateManagedWidget("main_w", xmMainWindowWidgetClass, toplevel,
			         NULL);
  /*   m e s s a g e a r e a   */
  mess.a=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, main_w,
				 XmNshadowType, XmSHADOW_OUT,
				 NULL);
  XtVaSetValues(main_w, XmNmessageWindow, mess.a, NULL);
  mess.rowcol_w=XtVaCreateManagedWidget("mess.a", xmRowColumnWidgetClass, mess.a,
			    XmNorientation, XmHORIZONTAL,
			    NULL);
  strcpy(message, "                                     ");
  mess.l=XtVaCreateManagedWidget("mess.l", xmLabelWidgetClass, mess.rowcol_w,
				 XmNlabelString, XmStringCreateLocalized(message),
				 XmNrecomputeSize, False,
				 NULL);

  /* form_w holds toolbar and drawing_a */
  form_w=XtVaCreateManagedWidget("form_w", xmFormWidgetClass, main_w,
				 NULL);
  /*   t o o l b a r   */
  toolb_w=XtVaCreateManagedWidget("Toolbar",xmToolbarWidgetClass,form_w,
			   XmNtipPosition, XmTIP_BOTTOM_RIGHT,
			   XtVaTypedArg, XmNbackground, XmRString, "#667788", 8,
			   XmNtopAttachment, XmATTACH_FORM,
			   XmNleftAttachment, XmATTACH_FORM,
			   XmNrightAttachment, XmATTACH_FORM,
			   XtVaTypedArg, XmNtipForeground,XmRString, "black", 6,
			   XtVaTypedArg, XmNtipBackground,XmRString, "yellow", 7,
			   NULL);
  /* Buttons for Toolbar */
  /* Zoom */
  mess.button_in=XtVaCreateManagedWidget("+", xmPushButtonWidgetClass, toolb_w,
					  XtVaTypedArg, XmNtipLabel,XmRString, "Zoom", 5,
					  NULL);
  SetPixmap(mess.button_in, zoom_in);
  XtAddCallback(mess.button_in, XmNactivateCallback, v_cb_add, (XtPointer)6);
  /* UnZoom */
  mess.button_out=XtVaCreateManagedWidget("-", xmPushButtonWidgetClass, toolb_w,
					  XtVaTypedArg, XmNtipLabel,XmRString, "UnZoom", 7,
					  NULL);
  SetPixmap(mess.button_out, zoom_out);
  XtAddCallback(mess.button_out, XmNactivateCallback, v_cb_add, (XtPointer)7);
  /* Fast left */
  mess.button_fb=XtVaCreateManagedWidget("<<", xmPushButtonWidgetClass, toolb_w,
					 XtVaTypedArg, XmNtipLabel,XmRString, "Fast Left", 10,
					 NULL);
  SetPixmap(mess.button_fb, Left);
  XtAddCallback(mess.button_fb, XmNactivateCallback, v_cb_add, (XtPointer)1);
  /* Left */
  mess.button_b = XtVaCreateManagedWidget("<", xmPushButtonWidgetClass, toolb_w,
					  XtVaTypedArg, XmNtipLabel,XmRString, "Left", 5,
					  NULL);
  SetPixmap(mess.button_b, left);
  XtAddCallback(mess.button_b, XmNactivateCallback, v_cb_add, (XtPointer)2);
  /* Right */
  mess.button_f = XtVaCreateManagedWidget(">", xmPushButtonWidgetClass, toolb_w,
					  XtVaTypedArg, XmNtipLabel,XmRString, "Right", 6,
					  NULL);
  SetPixmap(mess.button_f, right);
  XtAddCallback(mess.button_f, XmNactivateCallback, v_cb_add, (XtPointer)3);
  /* Fast Right */
  mess.button_ff=XtVaCreateManagedWidget(">>", xmPushButtonWidgetClass, toolb_w,
					 XtVaTypedArg, XmNtipLabel,XmRString, "Fast Right", 11,
					 NULL);
  SetPixmap(mess.button_ff, Right);
  XtAddCallback(mess.button_ff, XmNactivateCallback, v_cb_add, (XtPointer)4);
  /* set, clear, zoom to mark */
  /* set mark */
  mess.button_setmark=XtVaCreateManagedWidget("set mark", xmPushButtonWidgetClass, toolb_w,
					      XtVaTypedArg, XmNtipLabel,XmRString, "Set Mark", 9,
					      NULL);
  SetPixmap(mess.button_setmark, mark_set);
  XtAddCallback(mess.button_setmark, XmNactivateCallback, v_cb_add, (XtPointer)0);
  /* clear mark */
  mess.button_clearmark=XtVaCreateManagedWidget("clear mark", xmPushButtonWidgetClass, toolb_w,
						XtVaTypedArg, XmNtipLabel,XmRString, "Clear Mark", 11,
					 NULL);
  SetPixmap(mess.button_clearmark, mark_clear);
  XtAddCallback(mess.button_clearmark, XmNactivateCallback, v_cb_add, (XtPointer)5);
  /* zoom to mark */
  mess.button_zoommark=XtVaCreateManagedWidget("zoom_to_mark", xmPushButtonWidgetClass, toolb_w,
					       XtVaTypedArg, XmNtipLabel,XmRString, "Zoom to Mark", 13,
					       NULL);
  SetPixmap(mess.button_zoommark, mark_zoom);
  XtAddCallback(mess.button_zoommark, XmNactivateCallback, v_cb_add, (XtPointer)9);
  /* Zoom to Selection */
  mess.button_snip_sel=XtVaCreateManagedWidget("snip sel", xmPushButtonWidgetClass, toolb_w,
					       XtVaTypedArg,
					       XmNtipLabel,XmRString, "Zoom to Selection", 18,
					       NULL);
  SetPixmap(mess.button_snip_sel, zoom_sel);
  XtAddCallback(mess.button_snip_sel, XmNactivateCallback, v_cb_add, (XtPointer)8);
  /* Total View */
  mess.button_total=XtVaCreateManagedWidget("total", xmPushButtonWidgetClass, toolb_w,
					    XtVaTypedArg,
					    XmNtipLabel,XmRString, "Total View", 11,
					    NULL);
  SetPixmap(mess.button_total, total);
  XtAddCallback(mess.button_total, XmNactivateCallback, v_cb_add, (XtPointer)10);
  /* -------------- */
  /* end of toolbar */
  /* -------------- */

  /*   d r a w i n g a r e a   */
  drawing_a=XtVaCreateManagedWidget("drawing_a",xmDrawingAreaWidgetClass, form_w,
				    XmNtopAttachment, XmATTACH_WIDGET,
				    XmNtopWidget, toolb_w,
				    XmNbottomAttachment, XmATTACH_FORM,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNrightAttachment, XmATTACH_FORM,
				    XmNwidth, DISW,
				    XmNheight, DISH,
				    NULL);
  //  XtAddCallback(drawing_a, XmNinputCallback, mouse_trap, NULL);
  XtAddCallback(drawing_a, XmNexposeCallback, da_cb, NULL);
  XtAddEventHandler(drawing_a, ButtonReleaseMask | ButtonPressMask | PointerMotionMask, False, mouse_trap, NULL);

  /*   M e n u s y s t e m   */
  menubar = XmCreateMenuBar(main_w, "menubar",NULL,0);
  /*   F i l e m e n u   */;
  PullDown=XmCreatePulldownMenu(menubar, "FilePullDown", NULL,0);
  mymenu.file.f_menu=XtVaCreateManagedWidget("File",
			  xmCascadeButtonWidgetClass, menubar,
			  XmNlabelString, XmStringCreateLocalized("File"),
			  XmNmnemonic, 'F',
			  XmNsubMenuId, PullDown,
			  NULL);
  mymenu.file.n_data=XtVaCreateManagedWidget("New",
					  xmPushButtonGadgetClass, PullDown,
					  XmNmnemonic, 'N',
					  NULL);
  XtAddCallback(mymenu.file.n_data, XmNactivateCallback, f_cb, (XtPointer)0);
  mymenu.file.l_data=XtVaCreateManagedWidget("Load Data",
					     xmPushButtonGadgetClass, PullDown,
					     XmNmnemonic, 'L',
					     NULL);
  XtAddCallback(mymenu.file.l_data, XmNactivateCallback, f_cb, (XtPointer)1);
  mymenu.file.s_data=XtVaCreateManagedWidget("Save Data",
					     xmPushButtonGadgetClass, PullDown,
					     XmNmnemonic, 'S',
					     NULL);
  XtAddCallback(mymenu.file.s_data, XmNactivateCallback, f_cb, (XtPointer)2);
  XtVaCreateManagedWidget("separator", xmSeparatorGadgetClass, PullDown, NULL);
  mymenu.file.p_data=XtVaCreateManagedWidget("Print",
					     xmPushButtonGadgetClass, PullDown,
					     XmNmnemonic, 'P',
					     NULL);
  XtAddCallback(mymenu.file.p_data, XmNactivateCallback, p_cb, NULL);
  XtVaCreateManagedWidget("separator", xmSeparatorGadgetClass, PullDown, NULL);
  mymenu.file.quit=XtVaCreateManagedWidget("Quit",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'Q',
					   NULL);
  XtAddCallback(mymenu.file.quit, XmNactivateCallback, f_cb, (XtPointer)3);

  /*   E d i t m e n u   */;
  PullDown=XmCreatePulldownMenu(menubar, "EditPullDown", NULL,0);
  mymenu.edit.e_menu=XtVaCreateManagedWidget("Edit",
			  xmCascadeButtonWidgetClass, menubar,
			  XmNlabelString, XmStringCreateLocalized("Edit"),
			  XmNmnemonic, 'E',
			  XmNsubMenuId, PullDown,
			  NULL);
  mymenu.edit.mean=XtVaCreateManagedWidget("Mean",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'M',
					   NULL);
  XtAddCallback(mymenu.edit.mean, XmNactivateCallback, e_cb, (XtPointer)0);
  mymenu.edit.area=XtVaCreateManagedWidget("Area under the curve",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'A',
					   NULL);
  XtAddCallback(mymenu.edit.area, XmNactivateCallback, e_cb, (XtPointer)1);
  mymenu.edit.min=XtVaCreateManagedWidget("Minimum",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'i',
					   NULL);
  XtAddCallback(mymenu.edit.min, XmNactivateCallback, e_cb, (XtPointer)2);
  mymenu.edit.max=XtVaCreateManagedWidget("Maximum",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'x',
					   NULL);
  XtAddCallback(mymenu.edit.max, XmNactivateCallback, e_cb, (XtPointer)3);
  mymenu.edit.dif=XtVaCreateManagedWidget("Delta-Y",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'D',
					   NULL);
  XtAddCallback(mymenu.edit.dif, XmNactivateCallback, e_cb, (XtPointer)4);
  mymenu.edit.deltax=XtVaCreateManagedWidget("Delta-X (s)",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'X',
					   NULL);
  XtAddCallback(mymenu.edit.deltax, XmNactivateCallback, e_cb, (XtPointer)9);
  XtVaCreateManagedWidget("separator", xmSeparatorGadgetClass, PullDown, NULL);
  mymenu.edit.copy=XtVaCreateManagedWidget("Copy Channels",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'C',
					   NULL);
  XtAddCallback(mymenu.edit.copy, XmNactivateCallback, e_cb, (XtPointer)6);
  mymenu.edit.del=XtVaCreateManagedWidget("Delete Channels",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'l',
					   NULL);
  XtAddCallback(mymenu.edit.del, XmNactivateCallback, e_cb, (XtPointer)7);
  mymenu.edit.reduce=XtVaCreateManagedWidget("Reduce to Visible",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'R',
					   NULL);
  XtAddCallback(mymenu.edit.reduce, XmNactivateCallback, e_cb, (XtPointer)8);

  /*   C a l c u l a t e m e n u   */;
  PullDown=XmCreatePulldownMenu(menubar, "CalcPullDown", NULL,0);
  mymenu.calc.c_menu=XtVaCreateManagedWidget("Calculate",
			  xmCascadeButtonWidgetClass, menubar,
			  XmNlabelString, XmStringCreateLocalized("Calculate"),
			  XmNmnemonic, 'C',
			  XmNsubMenuId, PullDown,
			  NULL);
  mymenu.calc.hr1=XtVaCreateManagedWidget("Derived channels by Threshold",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'T',
					 NULL);
  XtAddCallback(mymenu.calc.hr1, XmNactivateCallback, c_cb, (XtPointer)0);
  mymenu.calc.hr2=XtVaCreateManagedWidget("Derived channels by Convolution",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'C',
					 NULL);
  XtAddCallback(mymenu.calc.hr2, XmNactivateCallback, c_cb, (XtPointer)1);
  XtVaCreateManagedWidget("separator", xmSeparatorGadgetClass, PullDown, NULL);
  mymenu.calc.filter=XtVaCreateManagedWidget("Butterworth Filter",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'B',
					 NULL);
  XtAddCallback(mymenu.calc.filter, XmNactivateCallback, c_cb, (XtPointer)2);
  mymenu.calc.interpol=XtVaCreateManagedWidget("Spline Interpolation",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'S',
					 NULL);
  XtAddCallback(mymenu.calc.interpol, XmNactivateCallback, c_cb, (XtPointer)3);
  mymenu.calc.movavg=XtVaCreateManagedWidget("Moving Average",
					     xmPushButtonGadgetClass, PullDown,
					     XmNmnemonic, 'M',
					     NULL);
  XtAddCallback(mymenu.calc.movavg, XmNactivateCallback, c_cb, (XtPointer)4);
  mymenu.calc.seqavg=XtVaCreateManagedWidget("SeQuential Average",
					     xmPushButtonGadgetClass, PullDown,
					     XmNmnemonic, 'Q',
					     NULL);
  XtAddCallback(mymenu.calc.seqavg, XmNactivateCallback, c_cb, (XtPointer)11);
  mymenu.calc.rectify=XtVaCreateManagedWidget("Rectify",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'R',
					 NULL);
  XtAddCallback(mymenu.calc.rectify, XmNactivateCallback, c_cb, (XtPointer)5);
  mymenu.calc.invert=XtVaCreateManagedWidget("Invert",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'I',
					 NULL);
  XtAddCallback(mymenu.calc.invert, XmNactivateCallback, c_cb, (XtPointer)6);
  mymenu.calc.differentiate=XtVaCreateManagedWidget("Differentiate",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'D',
					 NULL);
  XtAddCallback(mymenu.calc.differentiate, XmNactivateCallback, c_cb, (XtPointer)10);
  XtVaCreateManagedWidget("separator", xmSeparatorGadgetClass, PullDown, NULL);
  mymenu.calc.linear=XtVaCreateManagedWidget("Linear Transformation",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'L',
					 NULL);
  XtAddCallback(mymenu.calc.linear, XmNactivateCallback, c_cb, (XtPointer)7);
  mymenu.calc.twochtrans=XtVaCreateManagedWidget("tWo Channel Transformations",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'W',
					 NULL);
  XtAddCallback(mymenu.calc.twochtrans, XmNactivateCallback, c_cb, (XtPointer)12);
  mymenu.calc.fft=XtVaCreateManagedWidget("Fast Fourier Transformation",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'F',
					 NULL);
  XtAddCallback(mymenu.calc.fft, XmNactivateCallback, c_cb, (XtPointer)8);
  mymenu.calc.baro=XtVaCreateManagedWidget("Baroreflex",
					 xmPushButtonGadgetClass, PullDown,
					 XmNmnemonic, 'B',
					 NULL);
  XtAddCallback(mymenu.calc.baro, XmNactivateCallback, c_cb, (XtPointer)9);
  XtVaCreateManagedWidget("separator", xmSeparatorGadgetClass, PullDown, NULL);
  mymenu.calc.artifact=XtVaCreateManagedWidget("Artifact removal",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'A',
					   NULL);
  XtAddCallback(mymenu.calc.artifact, XmNactivateCallback, e_cb, (XtPointer)5);

  /*   V i e w m e n u   */;
  PullDown=XmCreatePulldownMenu(menubar, "ViewPullDown", NULL,0);
  mymenu.view.v_menu=XtVaCreateManagedWidget("View",
			  xmCascadeButtonWidgetClass, menubar,
			  XmNlabelString, XmStringCreateLocalized("View"),
			  XmNmnemonic, 'V',
			  XmNsubMenuId, PullDown,
			  NULL);
  mymenu.view.redraw=XtVaCreateManagedWidget("Redraw",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'R',
					   NULL);
  XtAddCallback(mymenu.view.redraw, XmNactivateCallback, v_cb, (XtPointer)0);
  XtVaCreateManagedWidget("separator", xmSeparatorGadgetClass, PullDown, NULL);
  mymenu.view.zoom=XtVaCreateManagedWidget("Zoom",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'Z',
					   NULL);
  XtAddCallback(mymenu.view.zoom, XmNactivateCallback, v_cb, (XtPointer)1);
  mymenu.view.total=XtVaCreateManagedWidget("Total View",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'T',
					   NULL);
  XtAddCallback(mymenu.view.total, XmNactivateCallback, v_cb, (XtPointer)2);
  XtVaCreateManagedWidget("separator", xmSeparatorGadgetClass, PullDown, NULL);
  mymenu.view.hide=XtVaCreateManagedWidget("Hide active channels",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'H',
					   NULL);
  XtAddCallback(mymenu.view.hide, XmNactivateCallback, v_cb, (XtPointer)3);
  mymenu.view.all=XtVaCreateManagedWidget("Show all channels",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'S',
					   NULL);
  XtAddCallback(mymenu.view.all, XmNactivateCallback, v_cb, (XtPointer)4);
  XtVaCreateManagedWidget("separator", xmSeparatorGadgetClass, PullDown, NULL);
  mymenu.view.comments=XtVaCreateManagedWidget("View Comments",
					   xmPushButtonGadgetClass, PullDown,
					   XmNmnemonic, 'V',
					   NULL);
  XtAddCallback(mymenu.view.comments, XmNactivateCallback, v_cb, (XtPointer)5);

  XtSetSensitive(mymenu.file.n_data,False);
  XtSetSensitive(mymenu.file.s_data,False);
  XtSetSensitive(mymenu.file.p_data,False);
  XtSetSensitive(mymenu.edit.mean,False);
  XtSetSensitive(mymenu.edit.area,False);
  XtSetSensitive(mymenu.edit.min,False);
  XtSetSensitive(mymenu.edit.max,False);
  XtSetSensitive(mymenu.edit.dif,False);
  XtSetSensitive(mymenu.edit.deltax,False);
  XtSetSensitive(mymenu.edit.copy,False);
  XtSetSensitive(mymenu.edit.del,False);
  XtSetSensitive(mymenu.edit.reduce,False);
  XtSetSensitive(mymenu.calc.hr1,False);
  XtSetSensitive(mymenu.calc.hr2,False);
  XtSetSensitive(mymenu.calc.filter,False);
  XtSetSensitive(mymenu.calc.interpol,False);
  XtSetSensitive(mymenu.calc.movavg,False);
  XtSetSensitive(mymenu.calc.seqavg,False);
  XtSetSensitive(mymenu.calc.rectify,False);
  XtSetSensitive(mymenu.calc.invert,False);
  XtSetSensitive(mymenu.calc.differentiate,False);
  XtSetSensitive(mymenu.calc.linear,False);
  XtSetSensitive(mymenu.calc.twochtrans,False);
  XtSetSensitive(mymenu.calc.fft,False);
  XtSetSensitive(mymenu.calc.baro,False);
  XtSetSensitive(mymenu.calc.artifact,False);
  XtSetSensitive(mymenu.view.redraw,False);
  XtSetSensitive(mymenu.view.zoom,False);
  XtSetSensitive(mymenu.view.total,False);
  XtSetSensitive(mymenu.view.hide,False);
  XtSetSensitive(mymenu.view.all,False);
  XtSetSensitive(mymenu.view.comments,False);
  XtSetSensitive(mess.rowcol_w,False);
  XtSetSensitive(toolb_w,False);
  XtManageChild(menubar);
  XmMainWindowSetAreas(main_w, menubar, NULL, NULL, NULL, form_w);

  XtRealizeWidget(toplevel);
  XtAppMainLoop(app);
}


Widget GetTopLevelShell(Widget w) {
  Widget top_w;
  top_w=w;
  while (!XtIsTopLevelShell(top_w)) top_w=XtParent(top_w);
  return(top_w);
}

void c_f_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int item_no=(int) client_data;

  Widget GetTopLevelShell(Widget w);
  
  switch (item_no) {
  case 0:     /* quit */
    XtPopdown(GetTopLevelShell(widget));
    break;
  }
}

/* SetPixmap procedure */
void SetPixmap(Widget w, char *pix[]) {
  Pixmap bitmap;
  int rc;
  rc=XpmCreatePixmapFromData(XtDisplay(w),
			     RootWindowOfScreen(XtScreen(w)),
			     pix, &bitmap, NULL, NULL);
  if (rc==0)
    XtVaSetValues(w, XmNlabelType, XmPIXMAP,
		  XmNlabelPixmap, bitmap,
		  NULL);
}
